CT_HideBAB = 0;
CT_RelocateTooltip = 0;

questfadefunction = function (modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		QUEST_FADING_ENABLE = nil;
		CT_Print("<CTMod> "..CT_MASTERMOD_ON_QUESTFADE, 1.0, 1.0, 0.0);
	else
		QUEST_FADING_ENABLE = 1;
		CT_Print("<CTMod> "..CT_MASTERMOD_OFF_QUESTFADE, 1.0, 1.0, 0.0);
	end
end
questfadeinitfunction = function (modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		QUEST_FADING_ENABLE = nil;
	else
		QUEST_FADING_ENABLE = 1;
	end
end
CT_RegisterMod(CT_MASTERMOD_MODNAME_QUESTFADING, CT_MASTERMOD_SUBNAME_QUESTFADING, 5, "Interface\\Icons\\INV_Misc_Note_04", CT_MASTERMOD_TOOLTIP_QUESTFADING, "on", nil, questfadefunction, questfadeinitfunction);

reloadfunction = function ()
	ConsoleExec("reloadui");
	CT_Print("<CTMod> "..CT_MASTERMOD_WARNING_RELOAD, 1, 1, 0);
end

resetfunction = function()
	CT_Print("<CTMod> "..CT_MASTERMOD_WARNING_RESET, 1, 1, 0);
end

CT_RegisterMod(CT_MASTERMOD_MODNAME_RELOAD, "", 5, "Interface\\Icons\\Ability_Whirlwind", CT_MASTERMOD_TOOLTIP_RELOAD, "switch", "", reloadfunction);
CT_RegisterMod(CT_MASTERMOD_MODNAME_RESET, "", 5, "Interface\\Icons\\Spell_Frost_WindWalkOn", CT_MASTERMOD_TOOLTIP_RESET, "switch", "", resetfunction);

local gryphonfunction = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_Print("<CTMod> " ..CT_MASTERMOD_ON_GRYPHONS, 1, 1, 0);
		MainMenuBarLeftEndCap:Hide();
		MainMenuBarRightEndCap:Hide();
	else
		CT_Print("<CTMod> "..CT_MASTERMOD_OFF_GRYPHONS, 1, 1, 0);
		MainMenuBarLeftEndCap:Show();
		MainMenuBarRightEndCap:Show();
	end
end

local gryphoninitfunction = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		MainMenuBarLeftEndCap:Hide();
		MainMenuBarRightEndCap:Hide();
	else
		MainMenuBarLeftEndCap:Show();
		MainMenuBarRightEndCap:Show();
	end
end

CT_RegisterMod(CT_MASTERMOD_MODNAME_GRYPHONS, "", 5, "Interface\\Icons\\Ability_EyeOfTheOwl", CT_MASTERMOD_TOOLTIP_GRYPHONS, "off", nil, gryphonfunction, gryphoninitfunction);

CT_Old_ShowSB_Update = ShapeshiftBar_Update;
function CT_ShapeshiftBar_Update()
	if ( CT_HideBAB == 1 ) then
		ShapeshiftBarFrame:Hide();
	else
		CT_Old_ShowSB_Update();
	end
end
ShapeshiftBar_Update = CT_ShapeshiftBar_Update;
	
local hidebarfunc = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_HideBAB = 1;
		CT_Print("<CTMod> "..CT_MASTERMOD_ON_HIDEBONUSBARS, 1, 1, 0);
	else
		CT_Print("<CTMod> "..CT_MASTERMOD_OFF_HIDEBONUSBARS, 1, 1, 0);
		CT_HideBAB = 0;
	end
	ShapeshiftBar_Update();
end

local hidebarinitfunc = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_HideBAB = 1;
	else
		CT_HideBAB = 0;
	end
	ShapeshiftBar_Update();
end
CT_RegisterMod(CT_MASTERMOD_MODNAME_HIDEBONUSBARS, "", 5, "Interface\\Icons\\Spell_Nature_Sleep", CT_MASTERMOD_TOOLTIP_HIDEBONUSBARS, "off", nil, hidebarfunc, hidebarinitfunc);

SlashCmdList["RESETOPTIONS"] = function(msg)
	CT_Options[UnitName("player")] = { };
	CT_Print("<CTMod> All options for this player have been reset. Please use the Reload Interface button in the Control Panel to reload interface.", 1, 1, 0);
end

SLASH_RESETOPTIONS1 = "/resetoptions";

if ( Cosmos_TurnOnFPSMove ) then
	Cosmos_TurnOnFPSMove(1);
	COS_COS_FPSMOVE = 1;
	Cosmos_RegisterCVar("COS_COS_FPSMOVE_X", 1);
else
	-- Not using Cosmos, so set it manually
	FramerateLabel:ClearAllPoints();
	FramerateLabel:SetPoint("TOPLEFT", "UIParent", "TOPLEFT", 0, 0);
end


if ( DB_VERSION ) then
	-- Reset Quest Timer Frame positioning
	QuestTimerFrame:ClearAllPoints();
	QuestTimerFrame:SetPoint("LEFT", "Minimap", "LEFT", -275, 0);
else
	-- Reset Quest Timer Frame positioning
	QuestTimerFrame:ClearAllPoints();
	QuestTimerFrame:SetPoint("LEFT", "Minimap", "LEFT", -360, 45);
end

function ct_QuestTimerFrame_OnShow()
	-- return
	return;
end
function ct_QuestTimerFrame_OnHide()
	-- return
	return;
end
-- Redefine how the show/hide happens
QuestTimerFrame_OnShow = ct_QuestTimerFrame_OnShow;
QuestTimerFrame_OnHide = ct_QuestTimerFrame_OnHide;

CT_OldDD_AddButton = UIDropDownMenu_AddButton;
function CT_NewDD_AddButton(info, level)
	if ( not level ) then
		level = 1;
	end
	
	local listFrame = getglobal("DropDownList"..level);
	local listFrameName = listFrame:GetName();
	local index = listFrame.numButtons + 1;
	local width;

	-- If too many buttons error out
	if ( index > UIDROPDOWNMENU_MAXBUTTONS ) then
		return;
	end
	CT_OldDD_AddButton(info, level);
end

UIDropDownMenu_AddButton = CT_NewDD_AddButton;

CT_oldGT_SetDefaultAnchor = GameTooltip_SetDefaultAnchor;

function CT_GT_SetDefaultAnchor(tooltip, parent) 
	if ( tooltip == GameTooltip and CT_RelocateTooltip == 1 ) then
		tooltip:SetOwner(parent, "ANCHOR_NONE");
		tooltip:ClearAllPoints();
		tooltip:SetPoint("TOP", "UIParent", "TOP");
	else
		CT_oldGT_SetDefaultAnchor(tooltip, parent);
	end
end

GameTooltip_SetDefaultAnchor = CT_GT_SetDefaultAnchor;

local relocatefunc = function(modId, text)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_RelocateTooltip = 1;
		CT_Print("<CTMod> "..CT_MASTERMOD_ON_RELOCATETT, 1, 1, 0);
	else
		CT_RelocateTooltip = 0;
		CT_Print("<CTMod> "..CT_MASTERMOD_OFF_RELOCATETT, 1, 1, 0);
	end
end

local relocateinitfunc = function(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_RelocateTooltip = 1;
	else
		CT_RelocateTooltip = 0;
	end
end
CT_RegisterMod(CT_MASTERMOD_MODNAME_RELOCATETT, CT_MASTERMOD_SUBNAME_RELOCATETT, 5, "Interface\\Icons\\INV_Misc_Map_01", CT_MASTERMOD_TOOLTIP_RELOCATETT, "off", nil, relocatefunc, relocateinitfunc);

CT_oldSetItemButtonCount = SetItemButtonCount;
function CT_newSetItemButtonCount(button, count)
	CT_oldSetItemButtonCount(button, count);
	getglobal(button:GetName().."Count"):SetText(button.count);
end
SetItemButtonCount = CT_newSetItemButtonCount;

function MasterLockFunction(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_LockMovables(1);
		CT_Print("<CTMod> " .. CT_MASTERMOD_UNLOCKED, 1, 1, 0);
	else
		CT_Print("<CTMod> " .. CT_MASTERMOD_LOCKED, 1, 1, 0);
		CT_LockMovables(nil);
	end
end

function MasterLockInitFunction(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_MF_ShowFrames = 1;
	else
		CT_MF_ShowFrames = nil;
	end
end

function MasterResetFunction(modId, text)
	CT_ResetMovables();
	CT_Print("<CTMod> " .. CT_MASTERMOD_RESET, 1, 1, 0);
	if ( text ) then text:SetText(""); end
end


CT_RegisterMod(CT_MASTERMOD_MODNAME_UNLOCK, CT_MASTERMOD_SUBNAME_UNLOCK, 1, "Interface\\Icons\\INV_Misc_Key_03", CT_MASTERMOD_TOOLTIP_UNLOCK, "off", nil, MasterLockFunction, MasterLockInitFunction, 11);
CT_RegisterMod(CT_MASTERMOD_MODNAME_RESETFRAMES, CT_MASTERMOD_SUBNAME_RESETFRAMES, 1, "Interface\\Icons\\INV_Misc_Key_04", CT_MASTERMOD_TOOLTIP_RESETFRAMES, "switch", "", MasterResetFunction, nil, 12);