CT_CurrHealth = 0;
CT_CurrMana = 0;

CT_AddMovable("CT_TicksFrame", "RIGHT", "LEFT", "Minimap", -14, 67);

tickfunction = function (modId)
	local val = CT_Mods[modId]["modStatus"]
	if ( val == "on" ) then
		CT_Print("<CTMod> " .. CT_TICKMOD_ON, 1.0, 1.0, 0.0);
		CT_TicksFrame:Show();
	else
		CT_TicksFrame:Hide();
		CT_Print("<CTMod> " .. CT_TICKMOD_OFF, 1.0, 1.0, 0.0);
	end
end

function tickInitFunction(modId)
	local val = CT_Mods[modId]["modStatus"];
	if ( val == "on" ) then
		CT_TicksFrame:Show();
	else
		CT_TicksFrame:Hide();
	end
end

CT_RegisterMod(CT_TICKMOD_MODNAME, CT_TICKMOD_SUBNAME, 4, "Interface\\Icons\\Spell_Nature_HealingTouch", CT_TICKMOD_TOOLTIP, "off", nil, tickfunction, tickInitFunction);

function CT_TickMod_FadeMana()
	if ( this.alphamana <= 0.25 ) then return; end
	this.alphamana = this.alphamana - 0.0075;
	CT_TicksMana:SetAlpha(this.alphamana);
end

function CT_TickMod_FadeHealth()
	if ( this.alphahealth <= 0.25 ) then return; end
	this.alphahealth = this.alphahealth - 0.0075;
	CT_TicksHealth:SetAlpha(this.alphahealth);
end

function CT_TickMod_Fade(elapsed)
	this.update = this.update + elapsed;
	if ( this.update >= 0.01 ) then
		this.update = this.update - 0.01;
		CT_TickMod_FadeMana();
		CT_TickMod_FadeHealth();
	end
end

function CT_TickMod_OnEvent(event)
	if ( event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH" and arg1 == "player" ) then
		local curr = UnitHealth("player");
		if ( curr > CT_CurrHealth and CT_CurrHealth ~= 0 ) then
			CT_TicksHealth:SetText("HP/Tick: |c00FFFFFF" .. curr-CT_CurrHealth .. "|r");
			CT_TicksFrame.alphahealth = 1;
			CT_TicksHealth:SetAlpha(1);
		end
		CT_CurrHealth = curr;
	end
	if ( event == "UNIT_MANA" or event == "UNIT_MAXMANA" and arg1 == "player" ) then
		local curr = UnitMana("player");
		if ( curr > CT_CurrMana and CT_CurrMana ~= 0 ) then
			CT_TicksMana:SetText("MP/Tick: |c00FFFFFF" .. curr-CT_CurrMana .. "|r");
			CT_TicksFrame.alphamana = 1;
			CT_TicksMana:SetAlpha(1);
		end
		CT_CurrMana = curr;
	end
	if ( event == "VARIABLES_LOADED" and UnitPowerType("player") > 0 ) then
		CT_TicksMana:Hide();
		CT_TicksFrame:SetHeight(25); -- Decrease height
	end
end

function CT_TickMod_OnEnter()
	if ( not CT_RegisterMod or CT_MF_ShowFrames ) then
		GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
		GameTooltip:SetText("Click to drag");
	end
end